# SoNodeEngine Class Reference
[Engine classes]

`#include <Inventor/engines/SoNodeEngine.h>`

Inheritance diagram for SoNodeEngine:

List of all members.

## Detailed Description

SoNodeEngine is the base class for Coin node engines.

Node engines have the same functionality as normal engines, except that they inherit SoNode, which makes it possible to insert node engines in the scene graph.

The main rationale for this class is to simplify the implementation of VRML interpolator nodes, which are in a sense engines embedded in the shape of ordinary nodes.

This class will likely be of no interest to the Coin application programmers, and you can safely ignore it.

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## Public Member Functions

void | evaluateWrapper (void)
virtual int | getOutputs (SoEngineOutputList &l) const
SoEngineOutput * | getOutput (const SbName &outputname) const
SbBool | getOutputName (const SoEngineOutput *output, SbName &outputname) const
virtual const SoEngineOutputData * | getOutputData (void) const=0
SbBool | isNotifying (void) const
virtual void | notify (SoNotList *nl)
virtual void | writeInstance (SoOutput *out)

## Static Public Member Functions

void | initClass (void)
SoType | getClassTypeId (void)

## Protected Member Functions

| SoNodeEngine (void)
virtual | ~SoNodeEngine ()
virtual void | evaluate (void)=0
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | inputChanged (SoField *which)
void | writeOutputTypes (SoOutput *out)

## Static Protected Member Functions

const SoFieldData ** | getFieldDataPtr (void)
const SoEngineOutputData ** | getOutputDataPtr (void)

## Constructor & Destructor Documentation

SoNodeEngine::SoNodeEngine | ( | void |  | ) | `[protected]`

| Default constructor.

SoNodeEngine::~SoNodeEngine | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoNodeEngine::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode. Reimplemented in SoVRMLColorInterpolator, SoVRMLCoordinateInterpolator, SoVRMLInterpolator, SoVRMLNormalInterpolator, SoVRMLOrientationInterpolator, SoVRMLPositionInterpolator, SoVRMLScalarInterpolator, and SoVRMLTimeSensor.

SoType SoNodeEngine::getClassTypeId | ( | void |  | ) | `[static]`

| This static method returns the SoType object associated with objects of this class. Reimplemented from SoNode.

void SoNodeEngine::evaluateWrapper | ( | void |  | ) |

| Triggers an engine evaluation.

int SoNodeEngine::getOutputs | ( | SoEngineOutputList & | l | ) | const`[virtual]`

| Adds all outputs to list. Returns the number of outputs added to the list.

SoEngineOutput * SoNodeEngine::getOutput | ( | const SbName & | outputname | ) | const

| Returns the output with name outputname, or `NULL` if no such output exists.

SbBool SoNodeEngine::getOutputName | ( | const SoEngineOutput * | output,
|  | SbName & | outputname
| ) | const

| Sets to the name of output. Returns `FALSE` if no such output is contained within the engine instance.

const SoEngineOutputData * SoNodeEngine::getOutputData | ( | void |  | ) | const`[pure virtual]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SbBool SoNodeEngine::isNotifying | ( | void |  | ) | const

| Returns whether we're in a notification process. This is needed to avoid double notification when an engine enables outputs during inputChanged().

void SoNodeEngine::notify | ( | SoNotList * | nl | ) | `[virtual]`

| Notifies all auditors for this instance when changes are made. Reimplemented from SoNode. Reimplemented in SoVRMLTimeSensor.

void SoNodeEngine::writeInstance | ( | SoOutput * | out | ) | `[virtual]`

| This method is called from write() if the actual writing pass of the write action is taking place. It dumps the node to the given out output stream. Reimplemented from SoNode.

void SoNodeEngine::evaluate | ( | void |  | ) | `[protected, pure virtual]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SbBool SoNodeEngine::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) | `[protected, virtual]`

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

void SoNodeEngine::inputChanged | ( | SoField * | which | ) | `[protected, virtual]`

| Called when an input is changed. The default method does nothing, but subclasses may override this method to do the The Right Thing when a specific field is changed. Reimplemented in SoVRMLTimeSensor.

const SoFieldData ** SoNodeEngine::getFieldDataPtr | ( | void |  | ) | `[static, protected]`

| Returns the SoFieldData class which holds information about inputs in this engine. Reimplemented from SoNode.

const SoEngineOutputData ** SoNodeEngine::getOutputDataPtr | ( | void |  | ) | `[static, protected]`

| Returns the SoEngineOutputData class which holds information about the outputs in this engine.

void SoNodeEngine::writeOutputTypes | ( | SoOutput * | out | ) | `[protected]`

| Writes the types of engine outputs for extension engines (i.e. engines not built in to Coin).

The documentation for this class was generated from the following files:

- SoNodeEngine.h
- SoNodeEngine.cpp